<?php
//Primitive DBAL for mysql
$xcKernelSkipDbError = false;
$xcKernelLastDbError = false;

global $mysqliDbLink;

function quote($string)
{
 global $mysqliDbLink;	
 return mysqli_real_escape_string($mysqliDbLink, $string);
}

//All DBALs (mysql excluded) must replace LIMIT with some other instruction.
function query($query, $dblink="")
{
  //mysql_query("SET NAMES 'cp1251'", $dblink);
  global $mysqliDbLink;
  if($dblink == "") $dblink = $mysqliDbLink;
  
  $result = mysqli_query($dblink, $query);
  if (mysqli_connect_errno())
  {
    global $xcKernelSkipDbError, $xcKernelLastDbError;
    if($xcKernelSkipDbError) {
      $xcKernelLastDbError = true;
      return null;
    }
    ob_end_clean();
    die('Query failed: ' . $query . ' ('.mysqli_connect_errno() . ': '.mysqli_connect_error() . ')');
  }
  return $result;
}

function fetch_assoc($rs)
{
 return mysqli_fetch_assoc($rs);
}

function free_result($rs)
{
 return mysqli_free_result($rs);
}

function connect($host, $user, $passw, $db, $collation = false)
{
 global $mysqliDbLink;
 //if(!extension_loaded("mysql")) dl("mysql.so");
 $dblink = mysqli_connect($host, $user, $passw, $db);
 
 //$dblink = mysql_connect();
 //mysql_select_db($db, $dblink);
 //if ($collation)  mysqli_query($dblink, "SET NAMES '".$collation."'");
 if ($collation)  mysqli_set_charset($dblink, $collation);

 
 $mysqliDbLink = $dblink;
 return $dblink;
}

function dbal_getlatestid($dblink) {
   return mysqli_insert_id($dblink);
}

function dbal_fetch_assoc_all($r) {
   //return mysqli_fetch_all($r, MYSQLI_ASSOC); // comments due to be unstable in low versions
   $data = array();
   while ($row = mysqli_fetch_assoc($r)) $data[] = $row;
   return $data;
}



?>
