<?php
//  maxsym     ...  
function UtilsCutSymbols($maxsym,$str) {
  $maxsym = (int)$maxsym;
  if($maxsym==0) return $str;
  if (strlen($str)>$maxsym) {
    return substr($str,0,$maxsym).' ...';
  } else {
    return $str;
  }
}

function RemoveEndLines($str) {
  return str_replace("\r",'',str_replace("\n",' ',$str));
}

function MGetMicroTime(){
    list($usec, $sec) = explode(" ",microtime());
    return (float)((float)$sec+(float)$usec);
}

function f_copy($dir, $dest)
{
   if ($open = opendir($dir))
   {
       while (false !== ($file = readdir($open)))
       {
             if ($file != "." && $file != "..")
             {
                 //echo "file=".$file."<br>";
                 if (!is_dir($dir ."/". $file))
                 {
                       //echo $file."<br>";
                       copy($dir."/".$file, $dest."/".$file);
                       chmod($dest."/".$file, 0777);
                 }
                 else
                 {
                  //echo $file." - created dir<br>";
                  mkdir($dest."/".$file, 0777);
                  chmod($dest."/".$file, 0777);
                  //     ,       :
                  f_copy($dir."/".$file, $dest."/".$file);
                 }
             }
         }
         closedir($open);
         return true;
   }
   return false;

}

function htmlXspecialchars($string, $ent=ENT_COMPAT, $charset='ISO-8859-1') {
return htmlspecialchars($string, $ent, $charset);
//return "";
}

function htmlXentities($string, $ent=ENT_COMPAT, $charset='ISO-8859-1') {
return htmlentities($string, $ent, $charset);
}

function htmlX_entity_decode($string, $ent=ENT_COMPAT, $charset='ISO-8859-1') {
return html_entity_decode($string, $ent, $charset);
}

function testAssertEqual($name, $startVal, $endVal) {
		$st = $name."... ";
		if($startVal === $endVal) {
			$st .= '<font color="green">OK</font><br />';
		} else {
			$st .= '<font color="red">FAIL!</font> ('.$startVal.' != '.$endVal.')<br />';
		}
		return $st;
}
function eregDep($pattern, $string) {
	if(function_exists('ereg')) {
		return ereg($pattern, $string);
	} else {
		return preg_match('/'.$pattern.'/', $string);
	}
}

?>
