<?php
/*!! Structure.Kernel.Wacko, Function.WikiPages:
*  {{ontolink name="System.Structure.Kernel.WackoOld" text="WackoOld"}}.
*   Wacko -    .  
*  *  e  ( QSMini)
*  *      ( INIT)
*  *  ,   AJAX-,       .
* @param $config    .     wakka.config.php
*/

class WackoExt extends WackoOld {
  var $ext_services="";
  var $ext_userinfo="";
  var $ext_usinfoload=0;
  var $do_time=0;
  var $atheme;
  var $aactions = array();
  var $acontent = false;
  var $extmodules = 0;

  var $cntid = 0;
  var $cntmax = 0;
  var $cntarr = array();
  
  var $ajqContent = "";

// Base features
  function WackoExt($config) {
    $this->WackoOld($config);
    $this->_formatter_noautolinks = true;

    // Adding different services



    /*
    foreach($res as $service) {
       $servname = $service["name"];
       $this->ServiceRunFile($servname,'init');
    }
    */
    $this->srvAllRunFile('init');

    // Using Ajax

    if($this->IsAjax()) {
        /*
        require_once($this->classes_dir."dyn.php");
        $JsHttpRequest =new Subsys_JsHttpRequest_Php("windows-1251");
        */
        require_once("js/JsHttpRequest/JsHttpRequest.php");
        $JsHttpRequest = new JsHttpRequest("windows-1251");
        GLOBAL $_RESULT;
        $_RESULT["ajaxsysmsg"] = "";
        $this->atheme = explode(";",$_REQUEST["divname"]);
        $this->aactions = explode(";",$_REQUEST["actions"]);

        if($this->atheme[0] == "content") {
            unset($this->atheme[0]);
            $this->acontent = true;
        }

        foreach($this->atheme as $key => $val) {
          if(!preg_match("/^\\w+$/",$val)) {
              unset($this->atheme[$key]);
          }
        }

        foreach($this->aactions as $key => $val) {
          if(!preg_match("/^\\w+$/",$val)) {
              unset($this->aactions[$key]);
          }
        }
    } else {
      $this->acontent = true;
    }

  }

//--------------------------------- WikiUpdate -------------------------------

/*!! Structure.Kernel.Wacko.RemoveActions, Function.Plugin:
*   ,   .          .
*       .      
* @param $pgid ID 
*/

  function RemoveActions($pgid) {
     $this->Query('DELETE FROM '.$this->config["table_prefix"]."actions WHERE page_id='".quote($pgid)."'");
  }

/*!! Structure.Kernel.Wacko.CanAction, Function.Access, Function.Plugin:
*  ,       .       actions.
* @param $action   (   ,   - )
* @param $pageid ,     
* @param $cond     SQL-.   .
* @return dbrow -   ,     ,    .        .
*/

  function CanAction($action,$pageid,$cond="") {
    return $this->Loadsingle("SELECT * FROM ".$this->config["table_prefix"]."actions WHERE actiontype='".quote($action)
    ."' AND page_id='".quote($pageid)."' ".$cond);
  }

/*!! Structure.Kernel.Wacko.CanThisPageAction, Function.Plugin, Function.Access, User.Admin:
*  ,        .  ,    ,              .
*          ,  .   TRUE   $this->cur_security.
*         .
* @param $action   (   ,   - )
* @return dbrow -   ,     ,    .        .
*/

  function CanThisPageAction($action) {
     $canact = $this->CanAction($action,$this->page["id"]);
     if($this->IsAdmin()) {
         if($canact!="") {
            if($_GET["del".$action]) {
               $this->Query("DELETE FROM ".$this->config["table_prefix"]."actions WHERE id='".quote($canact["id"])."'");
               $this->SetMessage("Action $action has been uninstalled.");
               $this->redirect($this->href());
            } else {
               echo "<div align='center'>Action $action installed. <a href=\"".$this->Href("","","del".$action."=1")."\">Uninstall</a></div><br />";
            }
         } else {
            if($_GET["add".$action]) {
               $this->Query("INSERT INTO ".$this->config["table_prefix"]."actions SET page_id='".quote($this->page["id"])."', actiontype='".quote($action)."'");
               $this->SetMessage("Action $action has been installed.");
               $this->redirect($this->href());
            } else {
               echo "<div align='center'>Action $action not installed. <a href=\"".$this->Href("","","add".$action."=1")."\">Install</a></div><br />";
            }

         }
     }
     return $canact || $this->cur_security;
  }

/*!! Structure.Kernel.Wacko.AddSimpleSpaces, Function.Other:
*       .
* @param string -
*/

   // formatter functions

   function AddSimpleSpaces($text) {
     return str_replace('&nbsp;',' ',$this->AddSpaces($text));
   }

   /**
   * @ignore
   */

   function LoadTopPages() {
       $pages = $this->LoadAll("select ".$this->pages_meta." from ".
           $this->config["table_prefix"]."pages where supertag rlike '^[A-Za-z_\\']*\$'".
           " and comment_on = ''");
       if ($pages){
          $this->CacheACLPages($pages);
          return $pages;
       }
   }

   /**
   * @ignore
   */

   function CacheACLPages(&$pages) {
          //       acl
          foreach($pages as $page){
            $this->CachePage($page, 1); // ??   
            $supertag_list[] = $page["supertag"];
          }

          //    acl
          for ($i=0; $i<count($supertag_list); $i++) {
            $supertag_str .= "'".quote($supertag_list[$i])."', ";
          }
          $supertag_str=substr($supertag_str,0,strlen($supertag_str)-2);

          //  
          if ( $read_acls = $this->LoadAll("select * from ".$this->config["table_prefix"]."acls where supertag in (".$supertag_str.") and privilege = 'read'")){
          for ($i=0; $i<count($read_acls); $i++) {
            $this->CacheACL($read_acls[$i]["supertag"], "read", 1,$read_acls[$i]);
          }
          }
   }

/*!! Structure.Kernel.Wacko.LoadIdByTag, Function.WikiPages:
*  (   )  ID    .
*/


   function LoadIdByTag($tag) {
     $pg=$this->LoadSingle('SELECT id FROM '.$this->config["table_prefix"]."pages WHERE tag='".quote($tag)."'");
     return $pg["id"];
   }

/*!! Structure.Kernel.Wacko.UseAutoJs, Function.Theme:
*   HTML,   JS-   'js/autoinc'.
*/
   function UseAutoJs() {
   /*
     $dir_pointer=opendir('js/autoinc');
     while ($res = readdir($dir_pointer)) {
       if(strstr($res,'.js')) {
          ?>
          <script language="javascript" type="text/javascript" src="<?php echo $this->GetConfigValue("root_url")."js/autoinc/".$res; ?>"></script>
          <?php
       }
     }
     */
     $cacheFileName = 'sites/'.$this->_crossSiteName.'/cache_events/_autoinc_js.php';
     if(!file_exists($cacheFileName)) {
       $fd = fopen($cacheFileName,'w+');
       $dir_pointer=opendir('js/autoinc');
       while ($res = readdir($dir_pointer)) {
         if(strstr($res,'.js')) {
            fwrite($fd,'<script language="javascript" type="text/javascript" src="'.$this->GetConfigValue("root_url")."js/autoinc/".$res.'"></script>'."\n");
         }
       }
       fclose($fd);
     }
     include($cacheFileName);
   }


/*!! Structure.Kernel.Wacko.srvAllMakeJS, Function.Extension:
*      MAKEJS,      "js/autoinc/autoext.js".   
*    JS   , ,   .
*/

   function srvAllMakeJS() {
     $cont = "";
     $res=$this->srvLoadAll();

     foreach($res as $service) {
       $servname = $service["name"];
       //$cont .= "\n// ---- service ".$servname." ---- \n";
       $cont .= $this->srvRunFileContent($servname,'makejs');
     }
     $fp = fopen($this->getSiteDataPath().'xml/autoext.js','w');
     fwrite($fp,$cont);
     fclose($fp);
   }


   // load language resources
/*!! Structure.Kernel.Wacko.srvAllLoadResource, Function.Config:
*     .
*/

   function srvAllLoadResource($lang,&$wackoResource) {
     $res=$this->srvLoadAll();
     foreach($res as $service) {
       $servname = $service["name"];
       //$this->ServiceRunFile($servname,$filename);
       if(file_exists('extensions/'.$servname.'/lang/wakka.'.$lang.'.php')) {
          include('extensions/'.$servname.'/lang/wakka.'.$lang.'.php');
          $wackoResource = array_merge((array)$wackoResource, (array)$serviceResource);
       }
     }
   }

//--------------------------------- AJAX -------------------------------

/*!! Structure.Kernel.Wacko.ajxElement, Function.AJAX, Function.Theme:
*   ,    "< >/elements".
* @param $elem     
* @return string   
*/

   function ajxElement($elem, $forceLinkTracking = 0)
   {
      $elem = trim($elem);
      //if (!$forceLinkTracking) $this->StopLinkTracking();
      $result = $this->IncludeBuffered(strtolower($elem).".php", "<i>Unknown block \"".strip_tags($elem)."\"</i>", "", "themes/".$this->GetConfigValue("theme")."/elements");
      //$this->StartLinkTracking();
      return $result;
   }

/*!! Structure.Kernel.Wacko.ajxElementsAllRun, Function.AJAX, Function.Theme:
*    .
* @link Version.QS.v3s1:
*     .    .
*/


   function ajxElementsAllRun()
   {
      global $_RESULT;
      $allElements = array();
      $dir_pointer=opendir("themes/".$this->GetConfigValue("theme")."/elements");
      while ($res = readdir($dir_pointer)) {
      if(strstr($res,'.php')) {
         $res1 = str_replace(".php","",$res);
         $allElements[$res1] = $this->ajxElement($res1);
      }
      }
      return $allElements;
   }


/*
   function JsElement($element) {
     return "document.getElementById('".$element."').innerHTML = req.responseJS.".$element.";\n";
   }
*/

/*!! Structure.Kernel.Wacko.ajxPhpElement, Function.AJAX, Function.Theme:
*   AJAX-       .
*/

   function ajxPhpElement($element) {
     global $_RESULT;
     $_RESULT[$element]=$this->ajxElement($element);

   }


/*!! Structure.Kernel.Wacko.IsAjax, Function.AJAX:
* ,       AJAX
* @return boolean
*/

   function IsAjax() {
     return $_GET["sender"]=="AJAX";
   }
   
	function IsAjaxJquery() {
     return $_GET["sender"]=="AJAXJQ";
   }

/*!! Structure.Kernel.Wacko.StartVirtual, Function.AJAX, Function.Actions:
*       AJAX.     FinishVirtual.
*/

   function StartVirtual() {
     ob_start();
   }

/*!! Structure.Kernel.Wacko.FinishVirtual, Function.AJAX, Function.Actions:
*     AJAX.  ,    StartVirtual  FinishVirtual ,  ,
*     AJAX   $kname,   .
* @param $kname  AJAX-.   ,     .
* @param $echoResult    .
*/
   function FinishVirtual($kname, $echoResult = true) {
     GLOBAL $_RESULT;
     $output = ob_get_contents();
     ob_end_clean();
     if($echoResult) {
        echo $output;
     }
     //$key = array_search($kname, $this->aactions);
     /*if ($key!=false) {
     //if(in_array($kname, $this->aactions)) {
        $_RESULT[$kname] = $output;
        //unset($this->aactions[$key]);
     }
     */
     foreach($this->aactions as $key => $val) {
          if($val==$kname) {
              $_RESULT[$kname] = $output;
              unset($this->aactions[$key]);
          }
      }
   }

/*!! Structure.Kernel.Wacko.ajxDynAction, Function.AJAX, Function.Actions:
*      AJAX- .
* @param string  .
* @param string   .
* @param integer   0,    .     .
* @link Examples.AJAX:
 2.    AJAX.   -     .
%%(php)
<?php
  //  
  $id = 'action'.$this->cntGetOne();
  echo $this->ajxDynAction($id,date('H:i:s'),'3000');
?>
%%
*/

   function ajxDynAction($id, $content, $timeout=0) {
      echo "<div id='".$id."'>";
        $this->StartVirtual();
           echo $content;
         if($timeout!=0) $this->ajxAddJs("setTimeout(\"doDyn('','','".$id."','','');\",".$timeout.");");
        $this->FinishVirtual($id);
      echo "</div>";
   }

/*!! Structure.Kernel.Wacko.Arefresh, Function.AJAX, Function.Actions:
*    AJAX,          .
*/


   function Arefresh() {
     if ($this->IsAjax()) {
       //echo "<script language=\"javascript\" onload=\"doDyn(curpage,'','','');\"></script>";
       $this->AddJs("doDyn('',thelements,'','');");
     } else {
       $this->redirect($this->href());
     }
   }

   /**
   * @ignore
   */

   function AddJs($oper) {
     if ($this->IsAjax()) {
       //echo "<script language=\"javascript\" onload=\"doDyn(curpage,'','','');\"></script>";
       GLOBAL $_RESULT;
       $_RESULT["ajaxsysmsg"] .= $oper;
     } else {
       //;
     }
   }

/*!! Structure.Kernel.Wacko.ajxAddJs, Function.AJAX:
*     JS    ,  AJAX  ,  .
* @param string JS-.
*/

   function ajxAddJs($oper) {
     $this->AddJs($oper);
     /*
     if(!$this->IsAjax()) {
          ?>

            <script language="JavaScript" type="text/javascript">
            <?php echo $oper; ?>
            </script>
          <?php
     }
     */
     if(!$this->IsAjax()) {
          ?>

            <script language="JavaScript" type="text/javascript">
            <?php echo "ajax_content_mod += '".quote($oper)."';"; ?>
            </script>
          <?php
     }
   }

/*!! Structure.Kernel.Wacko.ajxHref, Function.AJAX:
*  ,      AJAX-.
* @param string URL,    .
* @param string  -,  ';'
* @param string  
* @param string  ; ID ,    .
* @return string HTML- 
*/

   function ajxHref($href, $action, $text, $form = "", $statuselem = "") {
     return '<a href="'.$href.'" onclick="return doDyn(\''.quote($href)."','','".$action."','".$form."','".$statuselem."')\">".$text."</a>";
     //return '<a href="javascript:void(0);" onclick="return doDyn(\''.quote($href)."','','".$action."','".$form."','".$statuselem."')\">".$text."</a>";
   }

/*!! Structure.Kernel.Wacko.ajxFormOpen, Function.AJAX:
*  ,   AJAX-.
* @param string  ID 
* @param string     ,  ';'
* @param string  -  ,  ';'
* @return string HTML-,  
*/

   function ajxFormOpen($id,$thref,$actref,$statuselem = "ajax_loading") {
     return '<form id="'.$id.'" method="GET" onsubmit="return doDyn('."'','".quote($thref)."','".$actref."','".$id."','".$statuselem."');\">";
   }

//--------------------------------- Primitives -------------------------------

   // Virtual Forms functions
/*!! Structure.Kernel.Wacko.vfrmField, Function.VirtualForm:
*    .
*       .     
* "vfrm"()   $this->vfrm["state"] = "field", ,   
*  .
* @param string ,          ()
* @param string  .       ,  "int"  "int low=0 high=100"
* @param string ,  , ,    .
* @return string      .
*/
   function vfrmField($name,$type,$value) {
      // Prepare parameters to move to procedure. Because we call Format, we can't move it in procedure, and write it in global array.
      $this->vfrm = array();
      $this->vfrm["state"] = "field";
      $this->vfrm["name"] = $name;
      $this->vfrm["value"] = $value;

      $str = $this->Format('vfrm'.$type.'','post_wacko');

      $this->vfrm = array();
      return $str;
   }

/*!! Structure.Kernel.Wacko.vfrmProcess, Function.VirtualForm:
*    .
*       $name      $type.
* @param string  .       ,  "int"  "int low=0 high=100"
* @param string  ()  .
* @return string      .
*/
   function vfrmProcess($type,$name) {
      // Prepare parameters to move to procedure. Because we call Format, we can't move it in procedure, and write it in global array.
      $this->vfrm = array();
      $this->vfrm["state"] = "process";
      $this->vfrm["name"] = $name;

      $str = $this->Format('vfrm'.$type.'','post_wacko');

      $this->vfrm = array();
      return $str;
   }
   
   function vfrmProcessR($name, $type) {
	  return $this->vfrmProcess($type, $name);
   }

/*!! Structure.Kernel.Wacko.vfrmActionState, Function.VirtualForm:
*    .
*   ,  ,    ,      ("vfrm*.php").   "field",    , "process" -    .
* @return string "field"|"process" - .  .
*/
   function vfrmActionState() {
     return $this->vfrm["state"];
   }

/*!! Structure.Kernel.Wacko.cntReserve, Function.Other.IdGen:
*    -       ,  ,
*   cntGet,    .
* @param integer -  
*/

   function cntReserve($num) {
      $this->cntid++;
      $this->cntarr[$this->cntid]['base'] = $this->cntmax;
      $this->cntarr[$this->cntid]['cur'] = $num;
      $this->cntmax += $num;
      return $this->cntid;
   }

/*!! Structure.Kernel.Wacko.cntGet, Function.Other.IdGen:
*      ,   cntReserve.   
*    ,  die();
* @param key ,  cntReserve;
*/

   function cntGet($id) {
      if (0>=$this->cntarr[$id]['cur']) {
          echo 'Error in cntGet: too much identificators';
          die();
      }
      $res = $this->cntarr[$id]["base"]+$this->cntarr[$id]["cur"];
      $this->cntarr[$id]["cur"]--;
      return $res;
   }

/*!! Structure.Kernel.Wacko.cntGetOne, Function.Other.IdGen:
##function cntGetOne()##
*    .        ,        1 .
*/

   function cntGetOne() {
      $this->cntmax++;
      return $this->cntmax;
   }

/*!! Structure.Kernel.Wacko.NewSmarty, Function.Libs.Smarty:
##function NewSmarty()##
   Smarty.
@link Version.QS.v4s0:
 Smarty  PHP ($sm->php_handling = SMARTY_PHP_ALLOW);
@link Version.QS.v5s1:
  visualSmartyProc2 ( - VisualTheme)        ;
*/

   function NewSmarty() {
      require_once(SMARTY_DIR.'Smarty.class.php');
      require_once(SMARTY_DIR.'DebugSmarty.class.php');
      $sm = new DebugSmarty; // DebugSmarty class is special class for WackoWiki, where we can calculate time for fetch template and debug it (debug >= 2)
	  //$sm = new Smarty;
      $sm->php_handling = SMARTY_PHP_ALLOW;
	  
      $sm->plugins_dir[] = SMARTY_DIR.'plugins';
      $sm->plugins_dir[] = 'classes/smarty_plugins';
	  /* */
	  //$sm->addPluginsDir(SMARTY_DIR.'plugins');
      //$sm->addPluginsDir('classes/smarty_plugins');
      //if($this->srvIsInstalled("VisualTheme")) {
        $sm->register_prefilter("visualSmartyProc2");
      //}
      $sm->assign('themeurl', $this->GetConfigValue("theme_url"));
      $sm->assign('rooturl', $this->GetConfigValue("root_url"));
      $sm->assign('today', date("Y-m-d"));
      $sm->assign('yesterday', date("Y-m-d", mktime (0,0,0,date("m")  ,date("d")-1,date("Y"))));
      $sm->assign('isadmin', $this->IsAdmin());
      if($this->srvIsInstalled("AdvOntology")) {
         $servOnto = $this->srvFactory("AdvOntology");
         $sm->assign("curUserId", $servOnto->utilGetCurUserField("id"));
      }
      return $sm;
   }

   function smartyServicesPlugins($sm) {
      $this->_currentSmarty = $sm;
      $this->srvAllRunFile('smartyplugins');
   }

   function smartyWrapImages($html1) {
      $html = str_replace('<script src="js/','<script src="'.$mythis->GetConfigValue('theme_url').'js/',$html);
	  $html = str_replace('<img src="i','<img src="'.$this->GetConfigValue('theme_url').'i',$html1);
      $html = str_replace('<img src="I','<img src="'.$this->GetConfigValue('theme_url').'I',$html);
      $html = str_replace('background="i','background="'.$this->GetConfigValue('theme_url').'i',$html);
      $html = str_replace('background="I','background="'.$this->GetConfigValue('theme_url').'I',$html);
      $html = str_replace('background-image: url(i','background-image: url('.$this->GetConfigValue('theme_url').'i',$html);
      $html = str_replace('background-image: url(I','background-image: url('.$this->GetConfigValue('theme_url').'I',$html);
      return $html;
   }

//--------------------------------- Documentation -------------------------------

   // Recomendation functions
   /**
   *  .
   * @param $id ,    JS-.
   * @param $text  
   * @param $solution  
   * @param $level  : [critical|possible]
   */

   function docShowRecom($id,$text,$solution,$level = "critical") {
      $text = $this->Format($text);
      $solution = $this->Format($solution);
      if($level == "critical") {
          $color = '#F00';
      }
      if($level == "possible") {
          $color = '#22F';
      }
      $restext = '<div style="color: '.$color.'; ">'.$text.'</div>';
      echo '<div>'.$restext.'<div style="text-align: right;"><small><a href="'.$this->href().'" onclick="return ShowHideById(\''.$id.'\');">'.$this->GRV('rec.showsolution').'</a></small></div></div>';
      echo '<div id="'.$id.'" style="display: none; padding: 20px;">'.$solution.'</div>';
   }

   /**
   *    HTML-,      .
   * @param $docpath   
   */

   function docClearFolder($docpath) {
      $this->utilClearFolder($docpath,'.html');
    }

   /**
   *  
   * @param $files ,   ,     .
   * @param $docpath   
   */

    function docGen($files,$docpath) {
       $directory = $docpath;
       include("lib/phpdoc/phpdoc.php");
    }

//--------------------------------- Other -------------------------------

   // XML functions
   /**
   * @ignore
   */

   function VSXMLLoad($data,$keyname) {
    //  xml  
    $parser = xml_parser_create();
    xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
    xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
    xml_parse_into_struct($parser,$data,$values,$tags);
    xml_parser_free($parser);

    //    
    foreach ($tags as $key=>$val) {
        if ($key == $keyname) {
            $molranges = $val;
            //        
            //      
            for ($i=0; $i < count($molranges); $i+=2) {
                    $offset = $molranges[$i] + 1;
                $len = $molranges[$i + 1] - $offset;
                $tdb[] = $this->VSXMLParse(array_slice($values, $offset, $len));
            }
        } else {
            continue;
        }
    }
    return $tdb;
    }

   /**
   * @ignore
   */
    function VSXMLParse($mvalues) {
    for ($i=0; $i < count($mvalues); $i++)
        $mol[$mvalues[$i]["tag"]] = $mvalues[$i]["value"];
    return $mol;
    }

/*!! Structure.Kernel.Wacko.OneButtonAction, Function.Other, Function.Actions:
##function OneButtonAction($btnid,$btntext)##
   ,   .
*/
    function OneButtonAction($btnid,$btntext) {
      if($_REQUEST["run_".$btnid]!='1') {
		  
        echo $this->csrfadFormOpen($btnid);
        echo '<input type=hidden name="run_'.$btnid.'" value=1>';
        echo '<input type=submit class="btn" value="'.$btntext.'">';
        echo $this->FormClose();
        return false;
      } else {
		if(($csrfError = $this->csrfadCheckStandart($btnid)) === TRUE) {
        return true;
		} else {
		$this->SetMessage('OBA: '.$csrfError);	
		}
      }
    }

    function IsWap() {
      global $crossSiteSubdomain;

      return $crossSiteSubdomain == "wap";
    }

    function fullInstallExtension($serv_name) {
      if($resObject = $this->srvFactoryNoAccess($serv_name)) {
         if($this->srvInstallService($serv_name,array())) {
           if(file_exists('extensions/'.$serv_name.'/site_template_data')) {
              global $crossSiteName;

              @mkdir('sites/'.$crossSiteName.'/data/'.$serv_name, 0777);
              @chmod('sites/'.$crossSiteName.'/data/'.$serv_name, 0777);
              @f_copy('extensions/'.$serv_name.'/site_template_data','sites/'.$crossSiteName.'/data/'.$serv_name);
           }
           $this->clearEventCache();
           $this->srvRunOne($resObject, "onPostInstallFiles", array());
           //$this->SetMessage($serv_name." installed (minikernel mode)");
           //$this->redirect($this->href('','','rebuild=1&serv='.$serv_name.'&state=install'));

           $this->srvForceLoadAll();
           return true;
         } else {
           /*
           $this->SetMessage($serv_name." CAN'T be installed due some reason (minikernel mode)");
           $this->redirect($this->href('',''));
           */
           return false;
         }
       } else {
         if(file_exists('extensions/'.$serv_name.'/run/install.php')) {
           include('extensions/'.$serv_name.'/run/install.php');
         }
         $this->Query("INSERT ".$this->config["table_prefix"]."services SET name='".quote($serv_name)."', options=''");
         //$this->SetMessage($serv_name." installed (usual mode)");
         //$this->redirect($this->href('','','rebuild=1&serv='.$serv_name.'&state=install'));
         $this->srvForceLoadAll();
         return true;
       }
    }

    function instExtUtil1($serv_name) {
       /*
       $this->srvAllMakeJS();
       $this->srvClearCacheEvents();
       $servname = $serv_name;
       $this->SavePage($this->tag.'/'.$servname,'=='.$servname.' admin page=='."\n".$this->GRV($servname.'.adminpage'));
       */
    }

/*!! Structure.Kernel.Wacko.pageFullDelete, Function.WikiPages:
##function pageFullDelete($tag)##
   .
*/
    function pageFullDelete($tag) {
       if ($this->RemoveReferrers($tag))
       {

       }
       if ($this->RemoveLinks($tag))
       {

       }
       if ($this->RemoveAcls($tag))
       {

       }
       if ($this->RemovePage($tag))
       {

       }
       if ($this->RemoveWatches($tag))
       {

       }
       if ($this->RemoveComments($tag))
       {

       }
       $this->RemoveActions($this->page["id"]);
       $this->srvAllRunFile('removepage');
    //$this->RemoveArtefacts($tag);
    }
    
    function IsDownloadXML() {
    	return $this->method == "download.xml";
    }
    
    
    var $downloadXMLfilename;
    var $downloadXMLcontentType;
    var $downloadXMLfile;
    
    
    function StartDownloadFile($filename, $contentType = "application/download") {
    	//ob_start();
    	header("Cache-control: private");
        header("Content-Type: ".$contentType);
        header("Content-Disposition: attachment; filename=".$filename);
        //header("Content-Transfer-Encoding: binary");
        ob_start();
    }
    
    function FinishDownloadFile() {
		$output = ob_get_contents();
     	ob_end_clean();
     	//header("Content-Length: ".strlen($output)); 
        $this->downloadXMLfile = $output;    	
    }
    
    // js processing
    
    var $arInclJS = array();
    
    function jsUse($path) {
    	if(substr($path, 0, 7) != "http://") {
    		$path = $this->GetConfigValue("root_url").$path;
    	}
    	
    	$arSearch = array_search($path, $this->arInclJS);
    	if($arSearch === false) {
    		$this->arInclJS[] = $path;
    	}
    }
    
	function jsUseTheme($path) {
    	$path = $this->GetConfigValue("theme_url").$path;
    	
    	$arSearch = array_search($path, $this->arInclJS);
    	if($arSearch === false) {
    		$this->arInclJS[] = $path;
    	}
    }
    
    function jsUsedRender() {
    	$res = "";
    	foreach($this->arInclJS as $val) {
    		$res .= '<script type="text/javascript" src="'.$val.'"></script>'."\n";
    	}	
    	return $res;
    }

    // visual theme Smarty
    
	var $_smVT = null;

    function vtNewSmarty() {
       if($this->_smVT == null) {
           $mythis = $this;
           $sm = $mythis->NewSmarty();
           $def = str_replace("\\","/",getcwd()).'/themes/'.$mythis->config["theme"].'/';
           //$sm->template_dir = $def.'smarty/templates/';
           $sm->template_dir = $def;
           $sm->compile_dir = $def.'smarty/templates_c/';
           $sm->config_dir = $def.'smarty/config/';
           $sm->cache_dir = $def.'smarty/cache/';
           //$sm->left_delimiter = '{-';
           //$sm->right_delimiter = '-}';
           $this->_smVT = $sm;
       }
       return $this->_smVT;
    }
    
	function vtGetPagePathWithSpaces() {
      $mythis = $this;
      $steps = explode("/", $mythis->tag);

      $result = "";
      $links = array();
      $_links = array();
      for ($i=0;$i<count($steps)-1;$i++)
      {
        if ($i==0) $prev=""; else $prev=$links[$i-1]."/";
        $links[] =  $prev.$steps[$i];
      }
      for ($i=0;$i<count($steps)-1;$i++)
        $result.= $mythis->Link("/".$links[$i], "", $mythis->AddSimpleSpaces($steps[$i]))."/";
      $result.=$mythis->AddSimpleSpaces($steps[count($steps)-1]);
      return $result;
    }
	
	// csrf functions
	
	public function csrfGetTokenName() {
		return "csrf_qs_tn";
	}
	
	public function csrfGetSecretKey() {
		if (empty($_SESSION["csrf_sec"])) {
			$_SESSION["csrf_sec"] = $this->randomString(32);
		}
		return $_SESSION["csrf_sec"];
	}
	
	/**
	 * Generate a random string
	 *
	 * @param int $length
	 * @return string
	 */
	protected function randomString($length)
	{
		$seed = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijqlmnopqrtsuvwxyz0123456789';
		$max = strlen($seed) - 1;
		$string = '';
		for ($i = 0; $i < $length; ++$i) {
			$string .= $seed{intval(mt_rand(0.0, $max))};
		}

		return $string;
	}
	
	/**
	 * Generate a CSRF token
	 *
	 * @param  string $adddata additional data for check in token
	 * @return string
	 */
	public function csrfGetToken($adddata = "")
	{
		//$key = $result = preg_replace('/[^a-zA-Z0-9]+/', '', $key);
		//if($_SESSION["csrf_qs_token"] != "") return
		
		$time = time();
		$extra = sha1($time .':'. $this->GetUserName() . ':' . $adddata. ':' .$_SERVER['REMOTE_ADDR'] . $_SERVER['HTTP_USER_AGENT'] . $this->csrfGetSecretKey());
		// time() is used for token expiration
		//$token = base64_encode(time() . $extra . $this->randomString(32));
		$token = base64_encode( $time. $extra );
		//$_SESSION["csrf_qs_token"] = $token;

		return $token;
	}
	
	/**
	 * Check the CSRF token is valid
	 *
	 * @param  string  $token          The token string (usually found in $_POST)
	 * @param  string  $adddata        additional data for check in token	 
	 * @param  int     $timespan       Makes the token expire after $timespan seconds (null = never)
	 */
	
	public function csrfCheck($token, $adddata = "", $timespan = null)
	{
		//$key = $result = preg_replace('/[^a-zA-Z0-9]+/', '', $key);

		if (!$token) {
			return 'Missing CSRF form token.';
		}
		
		$decoded = base64_decode($token);
		
		if($decoded === false) {
			return 'Incorrect-formed CSRF form token.';
		}
		
		$time = intval(substr($decoded, 0, 10));
		//echo $time;

		if (sha1($time .':'. $this->GetUserName() . ':' . $adddata. ':' .$_SERVER['REMOTE_ADDR'] . $_SERVER['HTTP_USER_AGENT'] . $this->csrfGetSecretKey()) != substr($decoded, 10, 40)) {
			return 'Incorrect CSRF form token.';
		}

		// Check for token expiration
		if ($timespan != null && is_int($timespan) && $time + $timespan < time()) {
			return 'CSRF token has expired.';
		}
		
		return true;
	}
	
	public function csrfCheckStandart($timespan = null) {
		//echo $_REQUEST[$this->csrfGetTokenName()];
		return $this->csrfCheck($_REQUEST[$this->csrfGetTokenName()],"",$timespan);
	}
	
	public function csrfadCheckStandart($adddata = "", $timespan = null) {
		//echo $_REQUEST[$this->csrfGetTokenName()];
		return $this->csrfCheck($_REQUEST[$this->csrfGetTokenName()],$adddata,$timespan);
	}
	
	public function csrfFormOpen($method = "", $tag = "", $formMethod = "post", $formname="", $formMore="") {
		$result = $this->FormOpen($method,$tag,$formMethod,$formname,$formMore);
		$result .= "<input type=\"hidden\" name=\"".$this->csrfGetTokenName()."\" value=\"".$this->csrfGetToken()."\" />\n";
		return $result;
	}
	
	public function csrfadFormOpen($adddata, $method = "", $tag = "", $formMethod = "post", $formname="", $formMore="") {
		$result = $this->FormOpen($method,$tag,$formMethod,$formname,$formMore);
		$result .= "<input type=\"hidden\" name=\"".$this->csrfGetTokenName()."\" value=\"".$this->csrfGetToken($adddata)."\" />\n";
		return $result;
	}
	
	public function csrfHref($method = "", $tag = "", $params = "", $addpage=0, $handler = null) {
		$urladd = $this->csrfGetTokenName().'='.urlencode($this->csrfGetToken());
		if($params == "") {
			$params = $urladd;
		} else {
			$params .= '&'.$urladd;
		}
		return $this->Href($method, $tag, $params, $addpage, $handler);
	} 
}

// visualTheme - in extension.php

function visualSmartyProc2($tplsource, &$smarty) {
   global $wacko;
   $mythis = $wacko;
   $html = $tplsource;

   $res = explode('<!-- SmartyUp -->',$html);

   if($res[1]) {
      $res2 = explode('<!-- SmartyDown -->',$res[1]);
      $html = $res2[0];
   } else {
      $html = $tplsource;
   }

   // other processing
   $html = str_replace('<img src="i','<img src="{$themeurl}i',$html);
   $html = str_replace('<img src="I','<img src="{$themeurl}I',$html);
   $html = str_replace('background="i','background="{$themeurl}i',$html);
   $html = str_replace('background="I','background="{$themeurl}I',$html);
   $html = str_replace('background-image: url(i','background-image: url({$themeurl}i',$html);
   $html = str_replace('background-image: url(I','background-image: url({$themeurl}I',$html);

   $html = str_replace('<script type="text/javascript" src="js/','<script type="text/javascript" src="{$themeurl}js/',$html);
   $html = str_replace('<link rel="stylesheet" type="text/css" href="css/','<link rel="stylesheet" type="text/css" href="{$themeurl}css/',$html);
   
   $html = str_replace('<!-- SmartyIfAdmin -->','{if $isadmin}',$html);
   $html = str_replace('<!-- SmartyIfNotAdmin -->','{if not $isadmin}',$html);
   $html = str_replace('<!-- SmartyEndIf -->','{/if}',$html);
   
   $tmp1 = explode('<!-- SmartyAIBlock[', $html);

   $res = $tmp1[0];
   unset($tmp1[0]);
   foreach($tmp1 as $block) {
      $tmp2 = explode('] -->', $block, 2);
      $tmp3 = explode('<!-- /SmartyAIBlock -->', $tmp2[1]);
      $res .= $tmp2[0].$tmp3[1];
   }

   $html = $res;

   return $html;
}

//Autoinclude files from 'autoinc'

    //   
    global $crossSiteName;
    $cacheFileName = __DIR__.'/../sites/'.$crossSiteName.'/cache_events/_autoinc.php';
    if(!file_exists($cacheFileName)) {
       $fd = fopen($cacheFileName,'w+');
       fwrite($fd,"<?php\n");
       fwrite($fd,"  // This is an autogenerated file for add autoinc files (see classes/extension.php (end))\n");

       $dir_pointer=opendir(__DIR__.'/autoinc');
       while ($res = readdir($dir_pointer)) {
         if(strstr($res,'.php')) {
            fwrite($fd,"  require_once('".'classes/autoinc/'.$res."');\n");
         }
       }

       fwrite($fd,"?>");
       fclose($fd);
    }
    include($cacheFileName);

//    ?
/* */
global $wakkaConfig;
if(is_array($wakkaConfig)) {
	if($wakkaConfig["kernel_overload"] != "") {
		//      -   
		require_once(__DIR__.'/'.$wakkaConfig["kernel_overload"]);
	} else {
		require_once(__DIR__.'/wackofinal.php');
	}
} else {
	require_once(__DIR__.'/wackofinal.php');
} /* */
//require_once(__DIR__.'/wackofinal.php');


?>
